let configs = {
  readtool: {
    android: {
      schema:  "ivydadreadtool://",
      PKG: "com.ivydad.readtool",
      url: "http://service.ivydad.com/exploiter/app/android/ReadTool.apk",
      weixinUrl: "http://fusion.qq.com/cgi-bin/qzapps/unified_jump?appid=12141370",
    },
    ios: {
      schema: "ivydadReadtool://",
      url: "https://itunes.apple.com/us/app/chang-qing-teng-ba-ba-ying/id1021086502?l=zh&ls=1&mt=8",
      weixinUrl: "http://a.app.qq.com/o/simple.jsp?pkgname=com.ivydad.readtool&g_f=991653",
    }
  },
}

export default async function openApp(app) {
  app = app || 'readtool'
  postDownloadStat(app)
  await new Promise(resolve => setTimeout(resolve, 200))
  let {ios, android} = configs[app]

  if (isIos()) {
    window.location.href = ios.schema
    return setTimeout(() => {
      window.location.href = isWeixin() ? ios.weixinUrl : ios.url
    }, 2000)
  }
  console.log('loading schema')
  let mod = require('./inner/nativeSchema')
  // nuxt中，require的行为和标准的require行为不同，多做一个判断
  if (mod.nativeSchema) mod = mod.nativeSchema
  mod.loadSchema({
    // 通过NN打开某个链接
    schema: "",
    //schema头协议，实际情况填写
    protocal: android.schema,
    //发起唤醒请求后，会等待loadWaiting时间，超时则跳转到failUrl，默认3000ms
    loadWaiting:"3000",
    //唤起失败时的跳转链接，默认跳转到下载页
    failUrl: isWeixin() ? android.weixinUrl : android.url,
    // apk信息,请根据实际情况填写
    apkInfo:{
      PKG: android.PKG,
      // CATEGORY: "android.intent.category.DEFAULT",
      CATEGORY:"android.intent.category.BROWSABLE",
      ACTION: "android.intent.action.VIEW"
    }
  })
}

export function postDownloadStat(app) {
  let req = new XMLHttpRequest()
  req.open('POST', '/api/mobile/count/addDownloadCount')
  req.setRequestHeader("Content-type","application/json");
  req.send(JSON.stringify({
    app,
    place: window.location.href,
    type: isIos() ? 'ios' : 'android',
  }))
}

export function isWeixin() {
  return navigator.userAgent.toLowerCase().includes('micromessenger')
}

export const isIos = () => {
	const ua = navigator.userAgent.toLowerCase()
  return !!ua.match(/ip(hone|od|ad)/i)
}

export const isAndroid = () => {
	const ua = navigator.userAgent.toLowerCase()
  return u.includes('android')
}
